=== debian/changelog ===
gazebo (11.8.0+dfsg-1build1) jammy; urgency=medium

  * No-change rebuild against libtinyxml2-9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Nov 2021 17:34:17 +0000

gazebo (11.8.0+dfsg-1) unstable; urgency=medium

  * Install setup.* since there is a bash file in latest
  * New upstream version 11.8.0+dfsg
  * Update gtest patch

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 18 Aug 2021 17:09:30 +0000

gazebo (11.5.1+dfsg-3) experimental; urgency=medium

  * Remove previous patch, not working
  * Call default dh_auto_build in build-indep to get examples and worlds installed for gazebo-common

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 03 Jun 2021 14:06:46 +0000

gazebo (11.5.1+dfsg-2) experimental; urgency=medium

  * Include patch to make gazebo_test_fixture in ALL cmake target

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 26 May 2021 17:10:47 +0000

gazebo (11.5.1+dfsg-1) experimental; urgency=medium

  * Update debian/gitlab-ci.yml file
  * Bump compat to 13 and standards to 4.5.1
  * Exclude windows bat script and github actions code
  * Refresh patches to the new version
  * Remove patch merged upstream
  * New upstream version 11.5.1+dfsg

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 21 May 2021 15:09:15 +0000
